/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.workflow.api.jbpm;

import org.jbpm.graph.exe.ExecutionContext;
import org.jbpm.graph.exe.Token;

public class TokenContext {

	private Long rootTokenId = null;
	private Long tokenId = null;
	
	
	public Long getTokenId() {
		return tokenId;
	}

	public Long getRootTokenId() {
		return rootTokenId;
	}
	
	public TokenContext(Long rootTokenId){
		this(rootTokenId, rootTokenId);
	}
	
	public TokenContext(Long rootTokenId, Long tokenId){
		this.rootTokenId = rootTokenId;
		this.tokenId = tokenId;
	}
	
	public String toString(){
		StringBuffer tokenContext = new StringBuffer();
		tokenContext.append(String.valueOf(rootTokenId));
		if (tokenId != null){
			tokenContext.append("," + String.valueOf(tokenId));
		}
		return tokenContext.toString();
	}
	
	public static TokenContext fromTokenContex(String tokenContext){
		if (tokenContext.indexOf(",") > 0){
			String[] tokens  = tokenContext.split(",");
			return new TokenContext(Long.valueOf(tokens[0]), Long.valueOf(tokens[1]));
		}else{
			return new TokenContext(Long.valueOf(tokenContext));
		}
	}
	
	public static TokenContext fromExecutionContext(ExecutionContext executionContext){
		Token token = executionContext.getToken();
		if (token.isRoot())
			return new TokenContext(token.getId());
		else{
			return new TokenContext(executionContext.getProcessInstance().getRootToken().getId(), token.getId());
		}
	}
	
	

}
