/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.workflow.command;

import java.util.Map;

public class CmdObject {

	// CONTROL API
	public static final String START_BY_PROCESS_NAME = "START_BY_PROCESS_NAME";
	public static final String START_BY_PROCESS_NAME_AND_VARIABLES = "START_BY_PROCESS_NAME_AND_VARIABLES"; 
	public static final String ABORT = "ABORT";
	public static final String RESTART = "RESTART";
	public static final String STOP_ON_AUTOMATIC_TASK = "STOP_ON_AUTOMATIC_TASK";
	public static final String EXECUTE_TASK_BY_TASK_NAME = "EXECUTE_TASK_BY_TASK_NAME";
	public static final String EXECUTE_TASK_BY_TASK_ID = "EXECUTE_TASK_BY_TASK_ID";
	public static final String EXECUTE_TASK_WITH_STATUS_BY_TASK_NAME = "EXECUTE_TASK_WITH_STATUS_BY_TASK_NAME";
	public static final String EXECUTE_TASK_WITH_STATUS_BY_TASK_ID = "EXECUTE_TASK_WITH_STATUS_BY_TASK_ID";
	public static final String EXECUTE_TASK_BY_ACTOR_AND_TASK_NAME = "EXECUTE_TASK_BY_ACTOR_AND_TASK_NAME";
	public static final String EXECUTE_TASK_BY_ACTOR_AND_TASK_ID = "EXECUTE_TASK_BY_ACTOR_AND_TASK_ID";
	public static final String GET_GLOBAL_VARIABLE = "GET_GLOBAL_VARIABLE";
	public static final String GET_GLOBAL_VARIABLES = "GET_GLOBAL_VARIABLES";
	public static final String SET_GLOBAL_VARIABLE = "SET_GLOBAL_VARIABLE";
	public static final String SET_GLOBAL_VARIABLES = "SET_GLOBAL_VARIABLES";
	public static final String GET_TASK_VARIABLE = "GET_TASK_VARIABLE";
	public static final String GET_TASK_VARIABLES = "GET_TASK_VARIABLES";
	public static final String SET_TASK_VARIABLE = "SET_TASK_VARIABLE";
	public static final String SET_TASK_VARIABLES = "SET_TASK_VARIABLES";
	public static final String LINK_PROCESSES = "LINK_PROCESSES";
	
	public static final String ADVANCE_TASK_COMPLETION_BY_TASK_ID = "ADVANCE_TASK_COMPLETION_BY_TASK_ID";
	public static final String ADVANCE_TASK_COMPLETION_BY_TASK_NAME = "ADVANCE_TASK_COMPLETION_BY_TASK_NAME";
	public static final String START_TASK_BY_TASK_ID = "START_TASK_BY_TASK_ID";
	public static final String START_TASK_BY_TASK_NAME = "START_TASK_BY_TASK_NAME";
	public static final String START_TASK_BY_ACTOR_AND_TASK_ID = "START_TASK_BY_ACTOR_AND_TASK_ID";
	public static final String START_TASK_BY_ACTOR_AND_TASK_NAME = "START_TASK_BY_ACTOR_AND_TASK_NAME";
	
	public static final String REJECT_TASK_BY_TASK_ID = "REJECT_TASK_BY_TASK_ID";
	
	

	// CONTROL EXTENDED API
	public static final String FORCE_TOKEN_WITH_SINGLE_TOKEN = "FORCE_TOKEN_WITH_SINGLE_TOKEN";
	public static final String FORCE_TOKEN_WITH_MULTIPLE_TOKENS = "FORCE_TOKEN_WITH_MULTIPLE_TOKENS";	
	public static final String ARE_NODES_ON_SAME_TOKEN = "ARE_NODES_ON_SAME_TOKEN";	
	
	
	// QUERY API
	
	public static final String GET_PROCESS_GRAPH = "GET_PROCESS_GRAPH";
	public static final String GET_PROCESS_BY_ID = "GET_PROCESS_BY_ID";
	public static final String GET_PROCESS_BY_NAME = "GET_PROCESS_BY_NAME";
	public static final String GET_ALL_PROCESSES = "GET_ALL_PROCESSES";
	public static final String GET_ALL_PROCESSES_FILTERED_BY = "GET_ALL_PROCESSES_FILTERED_BY";
	public static final String GET_HUMAN_TASKS_BY_PROCESS_ID = "GET_HUMAN_TASK_BY_PROCESS_ID";
	public static final String GET_HUMAN_TASKS_BY_PROCESS_NAME = "GET_HUMAN_TASK_BY_PROCESS_NAME";
	public static final String GET_HUMAN_TASK_BY_PROCESS_ID_AND_TASK_NAME = "GET_HUMAN_TASK_BY_PROCESS_ID_AND_TASK_NAME";
	public static final String GET_SUBPROCESS_BY_PROCESS_ID = "GET_SUBPROCESS_BY_PROCESS_ID";
	public static final String GET_SUBPROCESS_BY_PROCESS_NAME = "GET_SUBPROCESS_BY_PROCESS_NAME";
	public static final String GET_ALL_PROCESSES_INSTANCES = "GET_ALL_PROCESSES_INSTANCES";
	public static final String GET_ALL_PROCESSES_INSTANCES_FOR_PROCESS_BY_ID = "GET_ALL_PROCESSES_INSTANCES_FOR_PROCESS_BY_ID";
	public static final String GET_ALL_PROCESSES_INSTANCES_FOR_PROCESS_BY_NAME = "GET_ALL_PROCESSES_INSTANCES_FOR_PROCESS_BY_NAME";
	public static final String GET_SUBPROCESS_INSTANCES_BY_PARENT_PROCESS_ID = "GET_SUBPROCESS_INSTANCES_BY_PARENT_PROCESS_ID";
	public static final String GET_PROCESS_INSTANCE_BY_ID = "GET_PROCESS_INSTANCE_BY_ID";
	public static final String GET_HUMAN_TASKS_INSTANCES_FOR_PROCESS_INSTANCE = "GET_HUMAN_TASKS_INSTANCES_FOR_PROCESS_INSTANCE";
	public static final String GET_HUMAN_TASKS_INSTANCES_FOR_PROCESS_INSTANCE_FILTERED = "GET_HUMAN_TASKS_INSTANCES_FOR_PROCESS_INSTANCE_FILTERED";
	public static final String GET_PROCESS_INSTANCE_GRAPH = "GET_PROCESS_INSTANCE_GRAPH";
	public static final String GET_LINKED_PROCESS_INSTANCES_FOR_PROCESS_INSTANCE = "GET_LINKED_PROCESS_INSTANCES_FOR_PROCESS_INSTANCE";
	public static final String GET_HUMAN_TASK_INSTANCE_STATUS = "GET_HUMAN_TASK_INSTANCE_STATUS";
	public static final String GET_PROCESS_INSTANCE_STATUS = "GET_PROCESS_INSTANCE_STATUS";
	public static final String GET_HUMAN_TASK_OUTGOING_VALUES_BY_PROCESS_NAME_AND_TASK_NAME = "GET_HUMAN_TASK_OUTGOING_VALUES_BY_PROCESS_NAME_AND_TASK_NAME";
	public static final String GET_HUMAN_TASK_OUTGOING_VALUES_BY_PROCESS_ID_AND_TASK_NAME = "GET_HUMAN_TASK_OUTGOING_VALUES_BY_PROCESS_ID_AND_TASK_NAME";
	public static final String GET_HISTORIC_LIST_OF_TASKS="GET_HISTORIC_LIST_OF_TASKS";
	
	public static final String GET_LATEST_DEFINITION_PROCESSES = "GET_LATEST_DEFINITION_PROCESSES";
	public static final String GET_LATEST_DEFINITION_PROCESSES_ONLY_STANDALONE = "GET_LATEST_DEFINITION_PROCESSES_ONLY_STANDALONE";
	public static final String GET_LATEST_DEFINITION_PROCESSES_BY_FILTER = "GET_LATEST_DEFINITION_PROCESSES_BY_FILTER";
	public static final String GET_ALL_PROCESSES_ONLY_STANDALONE = "GET_ALL_PROCESSES_ONLY_STANDALONE";
	
	
	public static final String GET_SUBPROCESS_TASKS_BY_PROCESS_ID = "GET_SUBPROCESS_TASKS_BY_PROCESS_ID";
	public static final String GET_SUBPROCESS_TASKS_BY_PROCESS_NAME = "GET_SUBPROCESS_TASKS_BY_PROCESS_NAME";
	
	public static final String GET_NEXT_TASKS_NAMES = "GET_NEXT_TASKS_NAMES";
	public static final String GET_TASK_DOCUMENTATION = "GET_TASK_DOCUMENTATION";
	public static final String GET_GENERATED_HUMAN_TASKS_INSTANCES = "GET_GENERATED_HUMAN_TASKS_INSTANCES";
	public static final String GET_GENERATED_HUMAN_TASKS_INSTANCES_FILTERED = "GET_GENERATED_HUMAN_TASKS_INSTANCES_FILTERED";
	
	public static final String GET_HUMAN_TASKS_INSTANCES_FOR_ACTOR = "GET_HUMAN_TASKS_INSTANCES_FOR_ACTOR";
	public static final String GET_HUMAN_TASKS_INSTANCES_FOR_PROCESS_INSTANCE_AND_ACTOR = "GET_HUMAN_TASKS_INSTANCES_FOR_PROCESS_INSTANCE_AND_ACTOR";
	
	
	public static final String REJECT_TASK_BY_ACTOR_AND_TASK_ID = "REJECT_TASK_BY_ACTOR_AND_TASK_ID";
	public static final String ADVANCE_TASK_COMPLETION_BY_ACTOR_AND_TASK_ID ="ADVANCE_TASK_COMPLETION_BY_ACTOR_AND_TASK_ID";
	public static final String ADVANCE_TASK_COMPLETION_BY_ACTOR_AND_TASK_NAME = "ADVANCE_TASK_COMPLETION_BY_ACTOR_AND_TASK_NAME";
	
	public static final String GET_PROCESS_PROPERTIES_BY_ID = "GET_PROCESS_PROPERTIES_BY_ID";
	public static final String GET_PROCESS_PROPERTIES_BY_NAME = "GET_PROCESS_PROPERTIES_BY_NAME";
	public static final String GET_HUMAN_TASK_INSTANCES_ASSIGNED_TO_ACTOR="GET_HUMAN_TASK_INSTANCES_ASSIGNED_TO_ACTOR";
	public static final String GET_HUMAN_TASK_INSTANCES_ASSIGNED_TO_ACTOR_WITH_VARS = "GET_HUMAN_TASK_INSTANCES_ASSIGNED_TO_ACTOR_WITH_VARS";
	
	public static final String GET_EMPTY_PDF = "GET_EMPTY_PDF"; 
	public static final String GET_FILLED_PDF = "GET_FILLED_PDF";
	public static final String GET_FDF_FROM_DB = "GET_FDF_FROM_DB";
	public static final String GET_DATAHANDLER_FROM_PDF = "GET_DATAHANDLER_FROM_PDF";
	public static final String FILL_PDF_DOCUMENT = "FILL_PDF_DOCUMENT";
	public static final String GET_TASK_ATTRIBUTES = "GET_TASK_ATTRIBUTES";

	
	public CmdObject(String completeMethodName,
			Map<String, Object> parametersMap) {
		super();
		this.completeMethodName = completeMethodName;
		this.parametersMap = parametersMap;
	}

	public String completeMethodName = null;
	public Map<String,Object> parametersMap = null;
		
	public String getCompleteMethodName() {
		return completeMethodName;
	}
	public void setCompleteMethodName(String completeMethodName) {
		this.completeMethodName = completeMethodName;
	}
	
}
