/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.workflow.command;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.Dom4JDriver;

public class XStreamCommandSerializer implements ICommandSerializer {


	public String asXML(CmdObject cmdObject) {

			XStream xstream = new XStream(new Dom4JDriver());
			xstream.alias("command", CmdObject.class);
			String streamedXMLCommand = xstream.toXML(cmdObject);
			return streamedXMLCommand;
	}

	public ResultObject fromXML(String streamedXMLResponse){
		
			XStream xStreamResObject = new XStream(new Dom4JDriver());
			xStreamResObject.alias("result", ResultObject.class);
			ResultObject resultObject = (ResultObject) xStreamResObject.fromXML(streamedXMLResponse);
			return resultObject;
	
	}

}
