/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.workflow.handler;

import org.jbpm.graph.def.ActionHandler;
import org.jbpm.graph.exe.ExecutionContext;
import org.jbpm.graph.exe.ProcessInstance;
import org.spagic.workflow.handler.notifierproxy.NotifierProxy;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.Dom4JDriver;

public class NotifyHandler implements ActionHandler {
	public void execute(ExecutionContext executionContext) throws Exception {
		ProcessInstance processInstance = executionContext.getProcessInstance();
		XStream xStreamResObject = new XStream(new Dom4JDriver());
		String streamedObject = (String) executionContext.getVariable("_SPAGIC_NOTIFY_URL");
		NotifierProxy proxy = new NotifierProxy();
		if (streamedObject != null) {
			//String url = (String) xStreamResObject.fromXML(streamedObject);
			String url = streamedObject;
			proxy.setEndpoint(url);
		}
		long piid = processInstance.getId();
		String piName = processInstance.getProcessDefinition().getName();
		try {
			proxy.notify(piid, piName);
		} catch (Throwable e) {
			e.printStackTrace();
		}finally{
			executionContext.getProcessInstance().end();
		}
	}
}
