/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/

package org.spagic.workflow.handler.notifierproxy;

public class NotifierServiceLocator extends org.apache.axis.client.Service implements NotifierService {

    public NotifierServiceLocator() {
    }


    public NotifierServiceLocator(org.apache.axis.EngineConfiguration config) {
        super(config);
    }

    public NotifierServiceLocator(java.lang.String wsdlLoc, javax.xml.namespace.QName sName) throws javax.xml.rpc.ServiceException {
        super(wsdlLoc, sName);
    }

    // Use to get a proxy class for Notifier
    private java.lang.String Notifier_address = "http://localhost:8080/SanitaConfigurationWSMock/services/Notifier";

    public java.lang.String getNotifierAddress() {
        return Notifier_address;
    }

    // The WSDD service name defaults to the port name.
    private java.lang.String NotifierWSDDServiceName = "Notifier";

    public java.lang.String getNotifierWSDDServiceName() {
        return NotifierWSDDServiceName;
    }

    public void setNotifierWSDDServiceName(java.lang.String name) {
        NotifierWSDDServiceName = name;
    }

    public Notifier getNotifier() throws javax.xml.rpc.ServiceException {
       java.net.URL endpoint;
        try {
            endpoint = new java.net.URL(Notifier_address);
        }
        catch (java.net.MalformedURLException e) {
            throw new javax.xml.rpc.ServiceException(e);
        }
        return getNotifier(endpoint);
    }

    public Notifier getNotifier(java.net.URL portAddress) throws javax.xml.rpc.ServiceException {
        try {
            NotifierSoapBindingStub _stub = new NotifierSoapBindingStub(portAddress, this);
            _stub.setPortName(getNotifierWSDDServiceName());
            return _stub;
        }
        catch (org.apache.axis.AxisFault e) {
            return null;
        }
    }

    public void setNotifierEndpointAddress(java.lang.String address) {
        Notifier_address = address;
    }

    /**
     * For the given interface, get the stub implementation.
     * If this service has no port for the given interface,
     * then ServiceException is thrown.
     */
    public java.rmi.Remote getPort(Class serviceEndpointInterface) throws javax.xml.rpc.ServiceException {
        try {
            if (Notifier.class.isAssignableFrom(serviceEndpointInterface)) {
                NotifierSoapBindingStub _stub = new NotifierSoapBindingStub(new java.net.URL(Notifier_address), this);
                _stub.setPortName(getNotifierWSDDServiceName());
                return _stub;
            }
        }
        catch (java.lang.Throwable t) {
            throw new javax.xml.rpc.ServiceException(t);
        }
        throw new javax.xml.rpc.ServiceException("There is no stub implementation for the interface:  " + (serviceEndpointInterface == null ? "null" : serviceEndpointInterface.getName()));
    }

    /**
     * For the given interface, get the stub implementation.
     * If this service has no port for the given interface,
     * then ServiceException is thrown.
     */
    public java.rmi.Remote getPort(javax.xml.namespace.QName portName, Class serviceEndpointInterface) throws javax.xml.rpc.ServiceException {
        if (portName == null) {
            return getPort(serviceEndpointInterface);
        }
        java.lang.String inputPortName = portName.getLocalPart();
        if ("Notifier".equals(inputPortName)) {
            return getNotifier();
        }
        else  {
            java.rmi.Remote _stub = getPort(serviceEndpointInterface);
            ((org.apache.axis.client.Stub) _stub).setPortName(portName);
            return _stub;
        }
    }

    public javax.xml.namespace.QName getServiceName() {
        return new javax.xml.namespace.QName("http://ws.configuration.sanita.eng.it", "NotifierService");
    }

    private java.util.HashSet ports = null;

    public java.util.Iterator getPorts() {
        if (ports == null) {
            ports = new java.util.HashSet();
            ports.add(new javax.xml.namespace.QName("http://ws.configuration.sanita.eng.it", "Notifier"));
        }
        return ports.iterator();
    }

    /**
    * Set the endpoint address for the specified port name.
    */
    public void setEndpointAddress(java.lang.String portName, java.lang.String address) throws javax.xml.rpc.ServiceException {
        
if ("Notifier".equals(portName)) {
            setNotifierEndpointAddress(address);
        }
        else 
{ // Unknown Port Name
            throw new javax.xml.rpc.ServiceException(" Cannot set Endpoint Address for Unknown Port" + portName);
        }
    }

    /**
    * Set the endpoint address for the specified port name.
    */
    public void setEndpointAddress(javax.xml.namespace.QName portName, java.lang.String address) throws javax.xml.rpc.ServiceException {
        setEndpointAddress(portName.getLocalPart(), address);
    }

}
