/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.workflow.logging.log;

import org.jbpm.graph.log.ActionLog;

public class FaultLog extends ActionLog {

	private static final long serialVersionUID = 1L;
	
	private long processId;
	private String processName;
	private String nodeName;
	
	public FaultLog() {}
	
	@Override
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("fault[");
		buffer.append(getAction());
		if (exception != null) {
			buffer.append(", threw '");
			buffer.append(getException());
			buffer.append("'");
		}
		buffer.append("]");
		return buffer.toString();
	}

	public long getProcessId() {
		return processId;
	}

	public void setProcessId(long processId) {
		this.processId = processId;
	}

	public String getProcessName() {
		return processName;
	}

	public void setProcessName(String processName) {
		this.processName = processName;
	}

	public String getNodeName() {
		return nodeName;
	}

	public void setNodeName(String nodeName) {
		this.nodeName = nodeName;
	}

}
